// SkiFree (89/92+) by PsiGoo (Michael Holt)


#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "extgraph.h"					// Thomas Nussbaumer's ExtGraph routines
#include "skisprites.h"				// Ski Sprites

//short _ti89; 
//#define _ti89
short _ti92plus;
#define _ti92p


char version[]="v0.5B";

#include "key.h"
#include "neo.h"							// Neo Engine: graphics engine
int settimer=0;								// timer
#include "ion.h"							// Ion Engine: ski engine
#include "game.h"							// game: movement routines
#include "goo.h"							// Collision/Animation engine
#include "font.h"							// font: tech
#include "bg.h"								// background


void invertselection(char w);
void game();
char checkrep(int num);


////////////////////////////////////////////////////////////////////////////////////////////////
// "When it all goes wrong again"..heh
////////////////////////////////////////////////////////////////////////////////////////////////
void _main(void)
{
	piece com[500];					// must equal
	comp = &com[0];
	ClrScr();
	OSContrastDn(); 																							// Graphics need a little lighter dark gray
	Control_int_1(SAVE); 																					// Redirect Interupt 1
	int esc=0,w=0;
	if(!neo_start()) goto quit; 																	// Start Neo Engine / quit immediately (if error)

menu:
	neo_next();																										// clear virtuals
	while(!esc){																									// menu loop while not pressing escape
		background();																								// display background
		DisplaySpriteString(10,45,"start",3);												// menu item 1
		DisplaySpriteString(10,55,"exit",3);												// menu item 2
		invertselection(w);																					// invert selection
		neo_display();																							// display virtuals
		if(PRESS_ESCAPE) esc++;																			// exit menu on escape
		if(PRESS_DOWN) {																						// move selection down
			w++; while(PRESS_DOWN){}
			if(w>1) w=0;}
		if(PRESS_UP){																								// move selection up
			w--; while(PRESS_UP){}
			if(w<0) w=1;}
		if(PRESS_ENTER&&w==0){game();while(PRESS_ESCAPE);goto menu;}// start game
		if(PRESS_ENTER&&w==1){esc=10;while(PRESS_ENTER);}						// escape menu
		neo_next();																									// clear virtuals
	}
	

// End Stuff
quit:
	OSContrastUp();																								// restore contrast

	Control_int_1(RESTORE); 																			// restore interupt

  neo_end(); 																										// restore memory taken by virtuals
}


void invertselection(char w){
	InvertGrayRect2B(8,w*10+44,55,w*10+53,virtual1+960,virtual2+960);}




void game(){
	int t;
	long wait_for;																								// waitfor: variable for gray sync
	
	ion_reset();																									// clear level

	ion_add(27,playerposition,20);																// player
	
	for(t=0;t<5;t++){ion_add(10,random(400)-90,random(400)-120);}	// dog
	for(t=0;t<5;t++){ion_add(15,random(400)-90,random(400)-120);}	// snowboarder
	for(t=0;t<5;t++){ion_add(2, random(400)-90,random(400)-120);}	// newbie


	ion_add(17,20,170);																						// start
	ion_add(18,20,1910);																					// finish

	for(t=0;t<10;t++){
		ion_add(37,random(32)+85,160*t+310);												// left arrow
		ion_add(20,random(32)+75,160*t+390);}												// right arrow

	for(t=0;t<5;t++) ion_add(6,random(400)-90,random(400)-120);		// bumps
	for(t=0;t<5;t++) ion_add(36,random(400)-90,random(400)-120);	// ramps
	for(t=0;t<5;t++) ion_add(38,random(400)-90,random(400)-120);	// rock.0
	for(t=0;t<5;t++) ion_add(39,random(400)-90,random(400)-120);	// rock.1

	for(t=0;t<15;t++) ion_add(random(2)+21,random(600)-180,random(500)-100);	// trees
	

	while(!(_rowread(ESC_ROW)&ESC_KEY)){													// loop while no escape
		wait_for = GetGraySwitchCount() + 2;												// gray sync
		while (GetGraySwitchCount() < wait_for);										// gray sync

		ion_cycle();																								// visuals
		
		for(t=0;t<comps;t++){																				// loop through level objects
			if(comp[t].y<comp[0].y-120&&checkrep(comp[t].type)){			// if outside surrounding area
				if(comp[t].type==7||comp[t].type==8||comp[t].type==9) comp[t].type=21;	// if burning tree: change to oak tree
				comp[t].x=random(400)-90;																// randomize x position
				comp[t].y=comp[0].y+random(400)+128;}}									// randomize y posotion based on player_y postion
			
		movement();goo();movement();goo();													// twice: better speed
		
		timer(T_COUNT);																							// timer system
	}
}


char checkrep(int num){
	switch(num){
		case 17:																										// start
		case 18:																										// finish
		case 19:																										// good arrow
		case 1:																											// bad arrow
		case 37:																										// right arrow
		case 20:return 0;}																					// left arrow, return false (can't repeat)
	return 1;																											// return true 							(can repeat)
}
